/*
ZOPE CONTROLLER LICENSE AGREEMENT
---------------------------------

1. This LICENSE AGREEMENT is between Bizar Software Pty Ltd ("Bizar"),
and the Individual or Organization ("Licensee") accessing and otherwise
using Zope Controller software in source or binary form and its associated
documentation.

2. Subject to the terms and conditions of this License Agreement, Bizar
hereby grants Licensee a nonexclusive, royalty-free, world-wide
license to reproduce, analyze, test, perform and/or display publicly,
prepare derivative works, distribute, and otherwise use Zope Controller
alone or in any derivative version, provided, however, that Bizar's
License Agreement and Bizar's notice of copyright, i.e., "Copyright (c)
2001 Bizar Software Pty Ltd; All Rights Reserved" are retained in
Zope Controller alone or in any derivative version prepared by Licensee.

3. In the event Licensee prepares a derivative work that is based on
or incorporates Zope Controller or any part thereof, and wants to make
the derivative work available to others as provided herein, then
Licensee hereby agrees to include in any such work a brief summary of
the changes made to Zope Controller.

4. Bizar is making Zope Controller available to Licensee on an "AS IS"
basis.  BIZAR MAKES NO REPRESENTATIONS OR WARRANTIES, EXPRESS OR
IMPLIED.  BY WAY OF EXAMPLE, BUT NOT LIMITATION, BIZAR MAKES NO AND
DISCLAIMS ANY REPRESENTATION OR WARRANTY OF MERCHANTABILITY OR FITNESS
FOR ANY PARTICULAR PURPOSE OR THAT THE USE OF ZOPE CONTROLLER WILL NOT
INFRINGE ANY THIRD PARTY RIGHTS.

5. BIZAR SHALL NOT BE LIABLE TO LICENSEE OR ANY OTHER USERS OF ZOPE
CONTROLLER FOR ANY INCIDENTAL, SPECIAL, OR CONSEQUENTIAL DAMAGES OR LOSS AS
A RESULT OF MODIFYING, DISTRIBUTING, OR OTHERWISE USING ZOPE CONTROLLER,
OR ANY DERIVATIVE THEREOF, EVEN IF ADVISED OF THE POSSIBILITY THEREOF.

6. This License Agreement will automatically terminate upon a material
breach of its terms and conditions.

7. Nothing in this License Agreement shall be deemed to create any
relationship of agency, partnership, or joint venture between Bizar and
Licensee.  This License Agreement does not grant permission to use Bizar
trademarks or trade name in a trademark sense to endorse or promote
products or services of Licensee, or any third party.

8. By copying, installing or otherwise using Zope Controller, Licensee
agrees to be bound by the terms and conditions of this License
Agreement.

$Id: alerts.c,v 1.3 2001/09/26 08:41:34 richard Exp $
*/

#include "global.h"

void alertUser(const char *message, const char *detail) {
//    PyObject *type, *value, *traceback, *str;
    SInt16 result;
//    char *s;
    struct AlertStdAlertParamRec alert = {
        1, //Boolean movable;
        0, // Boolean helpButton;
        NULL, // ModalFilterUPP filterProc;
        (ConstStringPtr)-1, // ConstStringPtr defaultText;
        NULL, // ConstStringPtr cancelText;
        NULL, // ConstStringPtr otherText;
        kAlertStdAlertOKButton, // SInt16 defaultButton;
        kAlertStdAlertCancelButton, // SInt16 cancelButton;
        kWindowDefaultPosition //UInt16 position;
    };
    pascal char m[255], d[255];

    m[0] = d[0] = 255;
/*    if (message == NULL) {
        PyErr_Fetch(&type, &value, &traceback);
        str = PyObject_Str(type);
        s = PyString_AsString(str);
        Py_DECREF(str);
        strncpy(&m[1], s, 255);
        str = PyObject_Str(value);
        s = PyString_AsString(str);
        Py_DECREF(str);
        strncpy(&d[1], s, 255);
        Py_XDECREF(type);
        Py_XDECREF(value);
        Py_XDECREF(traceback);
    } else{
*/
        strncpy(&m[1], message, 255);
        if (detail != NULL) {
            strncpy(&d[1], detail, 255);
        } else {
            d[0] = 0;
        }
//    }

    StandardAlert(kAlertStopAlert, m, d, &alert, &result);
}

int askUser(const char *question, const char *detail) {
    OSErr err;
    SInt16 result;
    struct AlertStdAlertParamRec replaceAlert = {
        1, //Boolean movable;
        0, // Boolean helpButton;
        NULL, // ModalFilterUPP filterProc;
        (ConstStringPtr)-1, // ConstStringPtr defaultText;
        (ConstStringPtr)-1, // ConstStringPtr cancelText;
        NULL, // ConstStringPtr otherText;
        kAlertStdAlertOKButton, // SInt16 defaultButton;
        kAlertStdAlertCancelButton, // SInt16 cancelButton;
        kWindowDefaultPosition //UInt16 position;
    };
    pascal char q[255], d[255];
    q[0] = d[0] = 255;
    strncpy(&q[1], question, 255);
    strncpy(&d[1], detail, 255);
    err = StandardAlert(kAlertCautionAlert, q, d, &replaceAlert, &result);
    if (result == kAlertStdAlertOKButton) {
        return 1;
    }
    return 0;
}
